<?php  
/**
Please Do not edit or add any code in this file without permission of bluezeal.in.
@copyright bluezeal.in
Prestashop version 1.6.0.14
CCAvenue MCPG Version 1.0
November 2014
**/
if (!defined('_PS_VERSION_'))
	exit;
 
if (defined('DOM_BZ_PATH_PG_MAIN_201')== false) {
	
	define("DOM_BZ_PATH_PG_MAIN_201",(dirname(__FILE__)."/common/"));
}
$cbdom_main=DOM_BZ_PATH_PG_MAIN_201."cbdom_main.php";  /* BZ =>this code neeed to define from ces_ccave_php_details.xls*/
$file_bz_dom= str_replace('\\','/',$cbdom_main);
/* need to be edit for every ecommerce path */
if (file_exists($file_bz_dom)) {
	include_once($file_bz_dom);
}
class ccavenue extends PaymentModule
{
	private	$_html = '';
	private $_postErrors = array();
	static  $params1;
	private $current_currency_id = '';
	private $_validateErrors = array();
	private	$_pgmod_ver			= "2.0";			/*==> Module Version*/
	private	$_pgcat				= "CCAvenue";		/*==>Category*/
	private	$_pgcat_ver  		= "MCPG-2.0";		/*==>Category Version*/
	private $_pgcms 			= "Prestashop";		/*==>CMS*/
	private	$_pgcms_ver 		= "1.6.1.0";		/*==>CMS Version*/
	private	$_pg_lic_key 		= 'FREE';			/*Payment module license key*/
	private	$_pg_install 		= false;	
	private	$_cbdom			= '';	
	private	$_cbdom_main	= '';	
	public function __construct()
	{
		$this->name 				= 'ccavenue';
		$this->tab 					= 'payments_gateways';
		$this->version 				= 'MCPG-2.0';
		$this->currencies 			= true;
		$this->currencies_mode 		= 'checkbox';
		$this->controllers 			= array('payment', 'validation');
		parent::__construct();		
		$this->_pg_install=true;
		$this->_postErrors 			= array();
		$this->page 				= basename(__FILE__, '.php');
        $this->displayName 			= $this->l('ccavenue MCPG');
        $this->description 			= $this->l('Accepts payments by ccavenue');
		$this->confirmUninstall 	= $this->l('Are you sure you want to delete your details ?');
		$this->_cbdom_main = new Cbdom_main();
		$this->loadDefaults();
	}
	public function install()
	{	
		$helper = new HelperForm();
		$helper->token 				= Tools::getAdminToken('AdminModules');
		$check_dom				    = $this->getCcavenueApi($helper->token);
		if($check_dom == false)
		{
			$this->_pg_install=false;
			$this->_errors[] = Tools::displayError("Unable to install the ccavenue module. Contact Admin");
			return false;
		}
		if (!parent::install()
			OR !Configuration::updateValue('CCAVENUE_MERCHANT_ID', '')
			OR !Configuration::updateValue('CCAVENUE_ACCESS_CODE', '')
			OR !Configuration::updateValue('CCAVENUE_ENCRYPTION_KEY', '')
			OR !Configuration::updateValue('CCAVENUE_PAYMENT_CURRENCY','')
			OR !Configuration::updateValue('CCAVENUE_PAYMENT_ORDER_STATUS', '')
			OR !Configuration::updateValue('CCAVENUE_TITLE', 'CCAvenue MCPG')
			OR !$this->registerHook('payment')
			OR !$this->registerHook('paymentReturn')
			OR !$this->registerHook('backOfficeHeader'))			
			return false;
			
		if($this->_pg_install==false) 
		{
			$this->errors[] = Tools::displayError("Unable to install the ccavenue module . Contact Admin");
			return false;
		}
		return true;
	}
	public function uninstall()
	{
		if (!Configuration::deleteByName('CCAVENUE_MERCHANT_ID')
		   OR !Configuration::deleteByName('CCAVENUE_ACCESS_CODE')
		   OR !Configuration::deleteByName('CCAVENUE_ENCRYPTION_KEY')
		   OR !Configuration::deleteByName('CCAVENUE_PAYMENT_CURRENCY')
		   OR !Configuration::deleteByName('CCAVENUE_PAYMENT_ORDER_STATUS')
		   OR !Configuration::deleteByName('CCAVENUE_TITLE')
		   OR !parent::uninstall())
		   return false;
		return true;
	}
	protected function loadDefaults()
	{
		if($this->_cbdom_main->checkDomExist() == false)
		{
			$this->uninstall();
			$this->_errors[]=$this->l('Error in ccavenue payment method contact support');
			return false;
		}
		$cbdom = new Cbdom();		
		$this->_cbdom=$cbdom;
		$_POST['ccavenuepay_license_key'] = $this->_pg_lic_key;
		if(!empty($_POST['ccavenuepay_license_key']))
		{
			$license_key = $_POST['ccavenuepay_license_key'];                                
			$checked  = $cbdom->check_license($license_key);  /* This will call the communication file function check_license*/
			$getres = json_decode($checked,true);
			if(!is_array($getres) || array_key_exists('error',$getres))
			{
				$_POST['ccavenuepay_status'] = 0;
			    $errortxt = "Not installed!!! Error:".$getres['error'];
			    $settings['ccavenuepay_status'] = 0;
			    $cbdom->send_error_mail($errortxt);
			}
			else
			{
				$settings['ccavenuepay_license_key'] = $this->_pg_lic_key;
				$settings['ccavenuepay_status'] = 0;
				/**
				* call install function fro inserting the module data into the user database
				*  and register on the API server
				* 
				*/  				
				$this->installbzCc($license_key);
				$success = $sucesstxt = 'You need to set configuration!!';
				$settings['ccavenuepay_license_key'] = $this->_pg_lic_key;
				if(isset($_POST['ajax']) && $_POST['ajax'] == 'true')
				{
					echo json_encode(array('error'=>$errortxt,'success'=>$success));
					exit;					
				}
		   	}
		}
		else 
		{
			/* Get the license key from databse*/
			$license_key = $this->_ccavenuepay_license_key;
			$license_key = $ccavenuepay_license_key;
			if(empty($license_key))
			{
				$_POST['ccavenuepay_status'] = 0;
				$sucesstxt = 'You need to set license key for complete installation!!';
			}
			/* API code for checking the inputed license key is in setting array.*/
			$settings['ccavenuepay_license_key'] = $this->_pg_lic_key;
			if(!empty($settings['ccavenuepay_license_key']))
			{
				$data['ccavenuepay_license_key'] = $settings['ccavenuepay_license_key'];
			}
			$data['ccavenuepay_license_key'] =  $ccavenuepay_license_key;
		}
		/*Store License key into the data arry from Databse*/
		$data['ccavenuepay_license_key'] = $this->_pg_lic_key;
		/* check license key after installation success */
		if(!empty($data['ccavenuepay_license_key'])){
       		$checkres  = $cbdom->check_license($data['ccavenuepay_license_key']);
			$getres = json_decode($checkres,true);
			if(!empty($getres['error'])){
				$data['display'] = $getres['error']; 
			}
		}
		else{
            $checkres  = $cbdom->check_license($data['ccavenuepay_license_key']);
			$getres = json_decode($checkres,true);
		}
		$data['ccavenuepay_license_key'] = $this->_pg_lic_key;
		$ccavenuepay_pdf_link 		= '';
		$ccavenuepay_video_link 	= '';
		$ccavenuepay_alert_message 	= '';
		if(!empty($data['ccavenuepay_license_key'])){  
			$checkres  = $cbdom->check_license($data['ccavenuepay_license_key']);
			$getres = json_decode($checkres,true);
			if(!empty($getres['error'])){
				$data['display'] = $getres['error'];
			}
			if(isset($getres['success'])){	
			
				$this->ccavenuepay_pdf_link 		= $getres['module_pdf_link'] ;
				$this->ccavenuepay_video_link 		= $getres['module_video_link'] ;
				$this->ccavenuepay_alert_message 	= $getres['module_alert_message'] ;
			}
		}
		else{
			 
            $checkres  = $cbdom->check_license($data['ccavenuepay_license_key']);
			$getres = json_decode($checkres,true);
		}
		unset($cbdom);	
		$file = DOM_BZ_PATH_PG_201."cbdom.php";
	}
	public function getContent()
	{
		$this->_html = '<h2>CCAvenue MCPG</h2>';
		if (isset($_POST['submitccavenue']))
		{
			if (empty($_POST['merchant_id']))
				$this->_postErrors[] = $this->l('CCAvenue Merchant id is required.');
		    if (empty($_POST['access_code']))
				$this->_postErrors[] = $this->l('CCAvenue Access Code is required.');
			if (empty($_POST['encryption_key']))
				$this->_postErrors[] = $this->l('CCAvenue Encryption Key is required.');
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('CCAVENUE_MERCHANT_ID', strval($_POST['merchant_id']));
				Configuration::updateValue('CCAVENUE_ACCESS_CODE', strval($_POST['access_code']));
				Configuration::updateValue('CCAVENUE_ENCRYPTION_KEY', strval($_POST['encryption_key']));
				Configuration::updateValue('CCAVENUE_TITLE', strval($_POST['ccavenue_title']));
				Configuration::updateValue('CCAVENUE_PAYMENT_CURRENCY', strval($_POST['ccavenue_payment_currency']));
				Configuration::updateValue('CCAVENUE_PAYMENT_ORDER_STATUS', strval($_POST['ccavenue_payment_order_status']));
				$this->displayConf();
			}
			else
			{
				$this->displayErrors();
			}
		}
		$this->displayccavenue();
		$this->displayFormSettings();
		return $this->_html;
	}
	public function displayConf()
	{
		$this->_html .= '
						<div class="conf confirm">
							<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
							'.$this->l('Settings updated').'
						</div>';
	}
	public function displayErrors()
	{
		$nbErrors = sizeof($this->_postErrors);
		$this->_html .= '
		<div class="alert error">
			<h3>'.($nbErrors > 1 ? $this->l('There are') : $this->l('There is')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3>
			<ol>';
		foreach ($this->_postErrors AS $error)
			$this->_html .= '<li>'.$error.'</li>';
			$this->_html .= '
			</ol>
		</div>';
	}
	public function displayccavenue()
	{
		$this->_html .='<fieldset class="form-wrapper" id="edit-ccavenue-main-panel">
							<div class="fieldset-wrapper" style="">
								<div id="ccavenue-main-panel-left" style="float:left; padding:  23px 5px 0px; border-right: 1px dashed #cccccc; height: 135px">
									<a href="https://www.bluezeal.in" target="_blank">
										<img typeof="foaf:Image" src="https://api.bluezeal.in/cca/images/logo.png" alt="Bluezeal Logo">
									</a><br><br> 
									<div>
										<b>	<font color="sky blue">We Make </font> 
											<font color="red"> Module </font>
											<font color="sky blue">  Simpler </font>
										</b>
										<span id="ccavenue_module_lic_key" style="display:none">'.BZCCPG_LICENCE_KEY.'</span>
										<span id="ccavenue_module_ver" style="display:none">'.BZCCPG_MOD_VERSION.'</span>
										<span id="ccavenue_module_name" style="display:none">'.BZCCPG_CMS.'</span>
									</div>
								</div>
								<div id="ccavenue-main-panel-midd" style="display: inline-block; margin-left: 20px;  float:left">
									<h3 class="panel-title">CCAvenue MCPG </h3>
									<br> 
									<a style="text-decoration: none; font-size:16px;font-family:Verdana, Geneva, sans-serif; color:#09F;">Module Version:</a>
									<a style="text-decoration: none;color:#390; font-family:Verdana, Geneva, sans-serif; font-size:12px; font-weight:bold">'.BZCCPG_MOD_VERSION.'</a>				  
									<br>
									<a style="text-decoration: none;" href="'.$this->ccavenuepay_pdf_link.'" target="_blank" style="color:#F00; font-family:Verdana, Geneva, sans-serif; font-size:10px;"> PDF Manual Guide</a>&nbsp;&nbsp;&nbsp; 
									<a style="text-decoration: none;" href="'.$this->ccavenuepay_video_link.'" style="color:#F00; font-family:Verdana, Geneva, sans-serif; font-size:10px;">Video Tutorial Guide </a><br> 
									<span>
										<a style="color: #1E91CF;text-decoration: none;" href="https://www.bluezeal.in/support" target="_blank">Support</a>
									</span>
								</div>
								<div class="ccavenue-panel-2" style="padding: 23px 5px 0px;height:135px; float: left; border-left: 1px dashed rgb(204, 204, 204); margin-left: 20px; display: none;">
									<div id="ccavenue_module_update_panel" style="float: left; border: 1px solid rgb(238, 238, 238); padding: 20px; display: none;">
										<a style="color:#09F; font-family:Verdana, Geneva, sans-serif; font-size:12px; font-size:15px"> Avilable Updated Version:</a> 
										<br>Module version  &nbsp;  &nbsp;  : &nbsp; &nbsp; <span id="new_module_version" style="font-size: 14px;font-weight: bold;color: green;"></span>
										<div style="display:none;">
											<br>Cms Version  &nbsp; &nbsp; &nbsp;  &nbsp;  &nbsp; : &nbsp; &nbsp; <span id="new_cms_ver" style="font-size: 14px;font-weight: bold;color: green;"></span>
											<br>Category Version  &nbsp;      : &nbsp; &nbsp; <span id="new_cat_ver" style="font-size: 14px;font-weight: bold;color: green;"></span>
										</div>
										<a>
											<span class="red small about fontstyle" style="color: blue;font-family:Verdana, Geneva, sans-serif; font-size:12px; font-size:14px;margin:5px; text-decoration: underline;" id="update_module_button" onclick="return update_newmodule();">Get Updated Module</span>
										</a>
									</div>
									<div id="ccavenue_file_download_panel" style="float: left; margin-left: 11px; margin-top: 40px; display: none;">
									<a class="ccavenue_file_download_module" href="" id="Download_file">
									<button type="button">Download!</button>
									</a>
								</div> 
							</div>
						</div>
					</fieldset>';
	}
	function getPaymentCurrencyDropDown($current_currency)
	{
		if($this->_cbdom_main->checkDomExist()==false)
		{
			$this->_errors[]=$this->l('Error in ccavenue payment method contact support');
			return false;
		}
		$allowed_currencies_options_html='';
		$currencies = Currency::getCurrencies(false, true);
		$ccavenue_payment_allowed_currencies = $this->_cbdom->getAllowedCurrencyList();
		$allowed_currencies_options_html .='<select style="width:150px" id="ccavenue_payment_currency" name="ccavenue_payment_currency" >';
			foreach($currencies as $currency)
			{
				if (in_array($currency['iso_code'], $ccavenue_payment_allowed_currencies))
				{
					$allowed_currencies_options_html .='<option value="'.$currency['iso_code'].'" ';
					if( $currency['iso_code'] == $current_currency)
					{
						$allowed_currencies_options_html .=' selected="selected" ';
					}
					$allowed_currencies_options_html .=' >'.$currency['name'].'</option>';
				}
			}
		$allowed_currencies_options_html .='</select>';
		return $allowed_currencies_options_html;
	}
	function getPaymentOrderStatusDropDown($current_order_status)
	{
		$allowed_order_status_options_html='';
		$order_states = OrderState::getOrderStates((int)$this->context->cookie->id_lang);
		$allowed_order_status_options_html .='<select style="width:150px" id="ccavenue_payment_order_status" name="ccavenue_payment_order_status" >';
			foreach($order_states as $ord_sta)
			{
				if ($ord_sta['invoice']==1 && $ord_sta['shipped']==0  && $ord_sta['paid']==1 )
				{
					$allowed_order_status_options_html .='<option value="'.$ord_sta['id_order_state'].'" ';
					if( $ord_sta['id_order_state'] == $current_order_status)
					{
						$allowed_order_status_options_html .=' selected="selected" ';
					}
					$allowed_order_status_options_html .=' >'.$ord_sta['name'].'</option>';
				}
			}
		$allowed_order_status_options_html .='</select>';
		return $allowed_order_status_options_html;
	}
	public function displayFormSettings()
	{
		$conf = Configuration::getMultiple(array('CCAVENUE_MERCHANT_ID', /*'CCAVENUE_LICENSE_KEY',*/ 'CCAVENUE_ACCESS_CODE', 'CCAVENUE_ENCRYPTION_KEY', 'CCAVENUE_TITLE','CCAVENUE_PAYMENT_CURRENCY','CCAVENUE_PAYMENT_ORDER_STATUS'));
		$merchant_id = array_key_exists('merchant_id', $_POST) ? $_POST['merchant_id'] : (array_key_exists('CCAVENUE_MERCHANT_ID', $conf) ? $conf['CCAVENUE_MERCHANT_ID'] : '');
		$access_code = array_key_exists('access_code', $_POST) ? $_POST['access_code'] : (array_key_exists('CCAVENUE_ACCESS_CODE', $conf) ? $conf['CCAVENUE_ACCESS_CODE'] : '');
		$encryption_key = array_key_exists('encryption_key', $_POST) ? $_POST['encryption_key'] : (array_key_exists('CCAVENUE_ENCRYPTION_KEY', $conf) ? $conf['CCAVENUE_ENCRYPTION_KEY'] : '');
		$ccavenue_title = array_key_exists('ccavenue_title',$_POST) ? $_POST['ccavenue_title'] : (array_key_exists('CCAVENUE_TITLE', $conf) ? $conf['CCAVENUE_TITLE'] : '');
		$ccavenue_payment_order_status = array_key_exists('ccavenue_payment_order_status',$_POST) ? $_POST['ccavenue_payment_order_status'] : (array_key_exists('CCAVENUE_PAYMENT_ORDER_STATUS', $conf) ? $conf['CCAVENUE_PAYMENT_ORDER_STATUS'] : '');
		$ccavenue_payment_currency = array_key_exists('ccavenue_payment_currency',$_POST) ? $_POST['ccavenue_payment_currency'] : (array_key_exists('CCAVENUE_PAYMENT_CURRENCY', $conf) ? $conf['CCAVENUE_PAYMENT_CURRENCY'] : '');
		$allowed_currencies_options_html =  $this->getPaymentCurrencyDropDown($ccavenue_payment_currency);
		$allowed_order_status_options_html = $this->getPaymentOrderStatusDropDown($ccavenue_payment_order_status);
		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post" style="clear: both;" name="ccavenue">
		<fieldset>
			<legend ><img src="../img/admin/contact.gif" />'.$this->l('Settings').'</legend>
			<label>'.$this->l('CCAvenue Title').'</label>
			<div class="margin-form" >
			<input type="text" size="35" name="ccavenue_title" value="'.htmlentities($ccavenue_title, ENT_COMPAT, 'UTF-8').'"  />
			</div>			
			<label>'.$this->l('CCAvenue Merchant ID').'</label>
			<div class="margin-form"><input type="text" size="35" name="merchant_id" value="'.htmlentities($merchant_id, ENT_COMPAT, 'UTF-8').'" /></div>
			<label>'.$this->l('CCAvenue Access Code').'</label>
			<div class="margin-form"><input type="text" size="85" name="access_code" value="'.htmlentities($access_code, ENT_COMPAT, 'UTF-8').'" /></div>
			<label>'.$this->l('CCAvenue Encryption Key').'</label>
			<div class="margin-form"><input type="password" size="85" name="encryption_key" value="'.htmlentities($encryption_key, ENT_COMPAT, 'UTF-8').'" /></div>
			<label>'.$this->l('CCAvenue Payment Currency').'</label>
			<div class="margin-form">
				'.$allowed_currencies_options_html.'
			</div>
			<label>'.$this->l('CCAvenue Payment Order Status').'</label>
			<div class="margin-form">
				'.$allowed_order_status_options_html.'
			</div>
			<br /><br /><br />
			<br /><center><input type="submit" name="submitccavenue" value="'.$this->l('Update settings').'" class="button" /></center>
		</fieldset>
		</form>';
		$this->ccavenue_bz_module_validation();
	}
	public function hookPayment($params)
	{
		global $smarty, $cookie;
		if (!$this->active)
			return ;
		$this->_validateErrors=array();	
		session_start();
		$_SESSION['params1']       = '';
		$_SESSION['cart_currency'] = '';
		$_SESSION['cart_amount']   = '';
		$_SESSION['params1']       = $params;
	
		if($cookie->__get("ccavenue_validate_error_message"))
		{
			$ccavenue_error_message = $cookie->__get("ccavenue_validate_error_message");
			if($ccavenue_error_message!='')
			{
				$this->context->controller->errors[]=$ccavenue_error_message;
				$cookie->__set("ccavenue_validate_error_message",'');
			}
	
		}
		$this->smarty->assign(array(
			'this_path' => $this->_path,
			'this_path_bw' => $this->_path,
			'this_path_ssl' => Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/'.$this->name.'/'
		));
		
		
		return $this->display(__FILE__, 'payment.tpl');
	}
	public function getCcavneueConvertOrderAmount($order_total_amt,$base_currency_id,$cart_currecny_id,$ccavnenue_payment_currency_id)
	{
		$ccavnenue_payment_currency   = new Currency((int)($ccavnenue_payment_currency_id));
		$cart_current_currency   	  = new Currency($cart_currecny_id);
		
		if($cart_current_currency->iso_code != $ccavnenue_payment_currency->iso_code)
		{
			/* convert cart currency to base currency */
			if($cart_currecny_id != $base_currency_id )
			{
				$base_currency      = new Currency((int)($base_currency_id));
				$order_total_amt 	= Tools::convertPriceFull($order_total_amt, $cart_current_currency, $base_currency);
				$convereted_amount 	= Tools::convertPriceFull($order_total_amt, $base_currency, $ccavnenue_payment_currency);
			}
			else
			{
				$convereted_amount 	= Tools::convertPriceFull($order_total_amt, $cart_current_currency, $ccavnenue_payment_currency);
			}
			$order_total_amt = $convereted_amount;
		
		}
		return $order_total_amt;
	}
	
	public function getPaymentDetails($params)
	{
		global $smarty, $cookie;
		if($this->_cbdom_main->checkDomExist()==false)
		{
			$this->_errors[]=$this->l('Error in ccavenue payment method contact support');
			return false;
		}
		$cbdom = $this->_cbdom;
		$billing_address   	= new Address(intval($params['cart']->id_address_invoice));
		$delivery_address  	= new Address(intval($params['cart']->id_address_delivery));
		$customer   	   	= new Customer(intval($params['cart']->id_customer));
		$merchant_id     	= trim(Configuration::get('CCAVENUE_MERCHANT_ID'));
		$access_code     	= trim(Configuration::get('CCAVENUE_ACCESS_CODE'));
		$encryption_key  	= trim(Configuration::get('CCAVENUE_ENCRYPTION_KEY'));
		$ccavenue_title  	= trim(Configuration::get('CCAVENUE_TITLE'));
		$ccavenue_payment_currency_iso = trim(Configuration::get('CCAVENUE_PAYMENT_CURRENCY'));
		$Redirect_Url		= 'http://'.htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'modules/ccavenue/validation.php';
		$Cancel_Url			= 'http://'.htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'modules/ccavenue/validation.php';
		$language			= $this->_cbdom->getAllowedLanguage();;
		$OrderId        	= date('Ymdhis'). '-' .intval($params['cart']->id) ;
		$order_total_amt	= $params['cart']->getOrderTotal(true, 3);
		$ccavnenue_payment_currency_id = Db::getInstance()->getValue("SELECT `id_currency`
										FROM `"._DB_PREFIX_."currency`
										WHERE `iso_code` = '".$ccavenue_payment_currency_iso."'");
		$cart_currency_id   = (int)($params['cart']->id_currency);
		$base_currency_id   = Configuration::get('PS_CURRENCY_DEFAULT');
		$land_id 			= $params['cart']->id_lang;
		$ccavenue_payment_total    = $this->getCcavneueConvertOrderAmount($order_total_amt,$base_currency_id,$cart_currency_id,$ccavnenue_payment_currency_id);
		$billing_name 		= $billing_address->firstname ." ". $billing_address->lastname;
		$bill_address 	    = $billing_address->address1 ." ". $billing_address->address2;
		$billing_city 		= $billing_address->city;
		$billing_zip 		= $billing_address->postcode;
		$billing_tel 		= $billing_address->phone;
		$billing_email		= $customer->email;
		$bill_country_obj	= new Country(intval($billing_address->id_country));
		$bill_state_obj		= new State(intval($billing_address->id_state));
		$billing_country 	= $bill_country_obj->getNameById($land_id,$billing_address->id_country);
		$billing_state 		= $bill_state_obj->getNameById($billing_address->id_state);	
		$merchant_param1 	= (int)($params['cart']->id);
		$merchant_param2 	= date('YmdHis');
		$merchant_param3 	= $params['cart']->secure_key;
		$cust_notes_message = Message::getMessageByCartId(intval($params['cart']->id));
		$cust_notes 		= $cust_notes_message['message'];
		$billing_cust_notes = $cust_notes;
		$delivery_name 		= $delivery_address->firstname." " . $delivery_address->lastname;
		$deli_address 	    = $delivery_address->address1 ." " . $delivery_address->address2;
		$delivery_city 		= $delivery_address->city;
		$delivery_zip 		= $delivery_address->postcode;
		$delivery_tel 		= $delivery_address->phone;
		$deli_country_obj	= new Country(intval($delivery_address->id_country));
		$deli_state_obj		= new State(intval($delivery_address->id_state));
		$delivery_country 	= $deli_country_obj->getNameById($land_id,$delivery_address->id_country);
		$delivery_state 	= $deli_state_obj->getNameById($delivery_address->id_state);	
		$merchant_data_array = array();
		$merchant_data_array['merchant_id']      	= $merchant_id;
		$merchant_data_array['order_id']        	= $OrderId;
		$merchant_data_array['currency']			= $ccavenue_payment_currency_iso;
		$merchant_data_array['amount']          	= $ccavenue_payment_total;
		$merchant_data_array['redirect_url']        = $Redirect_Url;		
		$merchant_data_array['cancel_url']          = $Cancel_Url;
		$merchant_data_array['language']			= $language;
		$merchant_data_array['billing_name']		= $billing_name;
		$merchant_data_array['billing_address']		= $bill_address;	
		$merchant_data_array['billing_city']		= $billing_city;
		$merchant_data_array['billing_state']		= $billing_state;
		$merchant_data_array['billing_zip']			= $billing_zip;	
		$merchant_data_array['billing_country']		= $billing_country; 
		$merchant_data_array['billing_tel']			= $billing_tel;
		$merchant_data_array['billing_email'] 		= $billing_email;
		$merchant_data_array['delivery_name']		= $delivery_name;
		$merchant_data_array['delivery_address']	= $deli_address;
		$merchant_data_array['delivery_city']		= $delivery_city;
		$merchant_data_array['delivery_state']		= $delivery_state;
		$merchant_data_array['delivery_zip']		= $delivery_zip;
		$merchant_data_array['delivery_country']	= $delivery_country;
		$merchant_data_array['delivery_tel']		= $delivery_tel;
		$merchant_data_array['merchant_param1']		= $merchant_param1;
		$merchant_data_array['merchant_param2']		= $merchant_param2;
		$merchant_data_array['merchant_param3']		= $merchant_param3;
		$data['button_confirm'] = 'confirm Order';
		$data['access_code']	= $access_code ; 		
		$data['action'] 		= $cbdom->getPaymentGatewayUrl();
		$db = Db::getInstance();
		$apidetails = $db->query($cbdom->getPgmDetails());
		$passdata = array("merchantdata"=>$merchant_data_array,"encryptkey"=>$encryption_key,"data"=>$data);
		$request_form = $cbdom->getfrontform($apidetails,json_encode($passdata,true));
		$ccavenue_payment_error_status='';
		$ccavenue_error_message='';
		if($cookie->__get("ccavenue_validate_error_message"))
		{
			$ccavenue_error_message = $cookie->__get("ccavenue_validate_error_message");
		}
		if($ccavenue_error_message!='')
		{		
			$ccavenue_payment_error_status='ERROR';
		} 
	 
		$ccavnenue_payment_currency   = new Currency((int)($ccavnenue_payment_currency_id));
		$ccavenue_payment_total_full = Tools::displayPrice($ccavenue_payment_total, $ccavnenue_payment_currency, false);
		$return_array=array();
		$return_array=array("ccavenue_title"	=> $ccavenue_title,
					  "request_form"			=> $request_form,
					  "payment_status"			=> $ccavenue_payment_error_status,
					  "message"					=> $ccavenue_error_message,
					  "ccavenue_payment_total"	=> $ccavenue_payment_total_full,
					  "currency_code"    		=> $ccavenue_payment_currency_iso);
		return $return_array;
	}
	public function seccode()
	{
		$customer = new Customer(intval($_SESSION['params1']['cart']->id_customer));
		$sec      = $customer->secure_key;
		return $sec;
	}
	public function hookPaymentReturn($params)
	{
		if (!$this->active)
		return;
		global $smarty;		 
		switch($params['objOrder']->getCurrentState())
		{
			case _PS_OS_PAYMENT_:
				$smarty->assign('payment_status', 'SUCCESSFUL');				 
				break;
			case _PS_OS_OUTOFSTOCK_:
				$smarty->assign('payment_status', 'PENDING');
				break;
			case _PS_OS_WS_PAYMENT_:
				$smarty->assign('payment_status', 'PENDING');
				break;
			case _PS_OS_CANCELED_:
				$smarty->assign('payment_status', 'PENDING');
				break;
			case _PS_OS_CCAVENUE:
				$smarty->assign('payment_status', 'DECLINED');				
				break;
			case _PS_OS_ERROR_:
			default:
				$smarty->assign('payment_status', 'ERROR');
				break;
		}
		$message='';
		$smarty->assign('message', $message);
		return $this->display(__FILE__, 'confirmation.tpl');
	}
	public function validateOrder($id_cart, $id_order_state, $amountPaid, $paymentMethod = 'Unknown', $message = NULL, $extraVars = array(), $currency_special = NULL, $dont_touch_amount = false,$secure_key = false, Shop $shop = null)
	{
		if (!$this->active)
			return;	
		$this->_validateErrors=array();		
		$currency = $this->getCurrency();
		$cart     = new Cart(intval($id_cart));
		$cart_currency = $_SESSION['params1']['cart']->id_currency;
		$cart_total    = $_SESSION['params1']['cart']->getOrderTotal(true, 3);
		$cart->id_currency = $cart_currency;
		$amountPaid        = $cart_total;
		$id_lang  = $_SESSION['params1']['cart']->id_lang;
		$subject  = 'CCAvenue Payment Status';
		$template = 'payment_success';
		$firstname  = $_SESSION['params1']['cookie']->customer_firstname;
		$lastname   = $_SESSION['params1']['cookie']->customer_lastname;
		$Order_Id   = $id_cart;
		$date_added     = $_SESSION['params1']['cookie']->date_add;
		$payment_method = $paymentMethod;
		$total          = $cart_total;
		$to             = $_SESSION['params1']['cookie']->email;	
		$templateVars                  = array('{firstname}' => $firstname,'{lastname}' => $lastname,'{Order_Id}' => $Order_Id,'{date_added}' => $date_added,'{payment_method}' => $payment_method,'{total}' => $total);
		$ccavenue_payment_success_mail = trim(Configuration::get('CCAVENUE_PAYMENT_SUCCESS_MAIL'));
		$payment_status='';
		if(isset($extraVars['payment_status']))
		{
			$payment_status =$extraVars['payment_status'];
		}
		if(($ccavenue_payment_success_mail) && ($id_order_state == '2'))
		{
			Mail::Send($id_lang, $template, $subject, $templateVars, $to, NULL, NULL, NULL, NULL, NULL, _PS_MODULE_DIR_.$this->name.'/mails/');
		}
		$cart->save();
		parent::validateOrder($id_cart, $id_order_state, $amountPaid, $paymentMethod, $message, $extraVars, $currency_special, true,$secure_key, null);
	}
	public function ccavenue_bz_module_validation()
	{		
		$payment_module_validate	= base64_decode('aHR0cHM6Ly9ibHVlemVhbC5pbi9tb2R1bGVfdmFsaWRhdGUvc3VjY2Vzcy5waHA=');
		$poststring	= "server_address=".$_SERVER['SERVER_ADDR']."&domain_url=".$_SERVER['HTTP_HOST']."&module_code=CCAVEN_N_PS";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$payment_module_validate);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,$poststring);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		$result = curl_exec($ch);
		curl_close($ch);
		return true;
	}
	public function getCcavenueApi($token)
	{	
		$key_dom="qdfd1i@uj9";
		$cbdom = new Cbdom_main();
		$dombz= $cbdom->getDomBz($this->_pgmod_ver,$this->_pgcat,$this->_pgcat_ver,$this->_pgcms,$this->_pgcms_ver,$this->_pg_lic_key,$token,$key_dom);		
		unset($cbdom);	
		return $dombz;
	}
	public function installbzCc($license_key)
	{
		$cbdom = new Cbdom();
		$db = Db::getInstance();	
		$cbdom->setBZCCLicenceApiTNPrefix(_DB_PREFIX_);
		$query_array = $cbdom->installMainApi($license_key);
		foreach($query_array as $tmp_query)
		{
			$sql_license_id = $db->query($tmp_query);			
		}
		 
		if(!is_array($sql_license_id)) {
			$count_key = 0;
		}
		else {
			$count_key = count($sql_license_id);
		}
		$res = $cbdom->setRegisterMainApi($count_key,$license_key);
		 
		if(isset($res['sql_update']))
		{
			$db->query($res['sql_update']);
		}
		unset($res['sql_update']);
		return json_encode($res);
	}		
	/**
	 * Hooks methods
	 */
	public function hookBackOfficeHeader($params){
		if(!(Tools::getValue('controller') == 'AdminModules' )){	 
		 
			return;
		}
		if(Tools::getValue('module_name') == 'ccavenue' ){	 
			$this->context->smarty->assign(array(
					'Ccavenue_module_dir' => _MODULE_DIR_.$this->name,
					'Ccavenue_base_uri' => _PS_BASE_URL_.__PS_BASE_URI__,
					'Ccavenue_base_url' => _PS_BASE_URL_,
					'Ccavenue_token' => Tools::getAdminTokenLite('AdminModules') 
					
				));		
			
			return $this->display(__FILE__, '/views/templates/admin/header.tpl');
		}
		return ;
		
	}
	public function checkCurrency($cart)
	{
		$currency_order = new Currency($cart->id_currency);
		$currencies_module = $this->getCurrency($cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
				if ($currency_order->id == $currency_module['id_currency'])
					return true;
		return false;
	}
}
?>
