<?php
/*
* 2007-2014 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2014 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/
/**
 * @since 1.5.0
 */
class CCAvenueValidationModuleFrontController extends ModuleFrontController
{
	public $ssl = true;
	public $display_column_left = false;
	/**
	 * @see FrontController::initContent()
	 */
	public function initContent()
	{
		parent::initContent();
		$id_cart = Tools::getValue('id_cart');
		$id_order = Tools::getValue('id_order');
		$cart = $this->context->cart;
		
		$params['cart'] = $this->context->cart;
		$payment_response = $this->module->getPaymentDetails($params);

		$this->context->smarty->assign(array(
			'request_form'=>$payment_response['request_form'],
			'ccavenue_title'=>$payment_response['ccavenue_title'],
			'order_total' => $this->context->cart->getOrderTotal(true, Cart::BOTH),
			'currency_code'	=> $payment_response['currency_code'],
			'ccavenue_payment_total'=> $payment_response['ccavenue_payment_total']			
		));
		$this->setTemplate('validation.tpl');
	}
}


